unit Unit1;

interface

uses
  Windows, SysUtils, Classes, Graphics, Controls, Forms,  
  Dialogs, pngimage, MPlayer, StdCtrls, messages, ComCtrls;

type
  TForm1 = class(TForm)
    OpenDialog1: TOpenDialog;
    MediaPlayer1: TMediaPlayer;
    Button1: TButton;
    ProgressBar1: TProgressBar;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    procedure OpenPic(FileName:string);
    procedure ProImage;
  end;

  trgb = record
   b,g,r: byte;
  end;
  ARGB = array [0..0] of TRGB;
  PARGB = ^ARGB;

  expoint = record
   A:extended;
   B:extended;
  end;  

  TWaveHeader = record
   Marker1:        Array [0..3] of Char;
   BytesFollowing: LongInt;
   Marker2:        Array [0..3] of Char;
   Marker3:        Array [0..3] of Char;
   Fixed1:         LongInt;
   FormatTag:      Word;
   Channels:       Word;
   SampleRate:     LongInt;
   BytesPerSecond: LongInt;
   BytesPerSample: Word;
   BitsPerSample:  Word;
   Marker4:        Array [0..3] of Char;
   DataBytes:      LongInt;
end;

var
  Form1: TForm1;
  sour:tbitmap;
  PS:array of PARGB;
  head1:TWaveHeader;
  Channels,Resolution:word;
  SampleRate,Duration:longint;
  data1:array of byte;
  musfile:string;

implementation

{$R *.dfm}

procedure TForm1.OpenPic(FileName:string);
 var ext:string;
 i:integer;
 PNG: TPNGObject;
begin
 ext:=LowerCase(ExtractFileExt(FileName));
 if ext='.png' then  begin
  PNG:=TPNGObject.Create;
  try
   PNG.LoadFromFile(FileName);
   sour.Width:=PNG.Width;
   sour.Height:=PNG.Height;
   sour.Canvas.Draw(0,0,PNG);
  finally
   PNG.Free;
  end;
  setlength(PS,sour.Height);
  for i:=0 to High(PS) do PS[i]:=sour.scanline[i];
  musfile:=LowerCase(ExtractFileName(FileName));
  delete(musfile,length(musfile)-3,4);
  musfile:=musfile+'.wav';
 end;
end;

function Ang2Point(angle,R:extended):expoint;// 0-360,   12:00   ,  -      R   (0,0)
 var z:integer;
begin
 z:=trunc(angle/180);
 case z of
 0:begin
   result.A:=r*sin(pi*angle/180);
   result.B:=r*-cos(pi*angle/180);
  end;
 1:begin
   angle:=angle-180*z;
   result.A:=r*-sin(pi*angle/180);
   result.B:=r*cos(pi*angle/180);
  end;
 end;
end;

function Doedin(x:extended):integer; //,  
begin
 if trunc(frac(x)*10)>4 then result:=trunc(x)+1 else result:=trunc(x);
end;

function FindCenter:expoint;
 var i,j:integer;
 c,cx,cy:integer;
begin
 cx:=0;
 cy:=0;
 c:=0;
 for i:=500 to 1500 do begin   //      
  for j:=500 to 1500 do begin
   if (PS[i,j].r<20) then begin
    inc(c);
    cx:=cx+j;
    cy:=cy+i;
   end;
  end;
 end;
 result.B:=cx/c;
 result.A:=cy/c;
end;

procedure TForm1.ProImage;
 var i,j,k:integer;
 z:expoint;
 c:expoint;
 delta,ugol,DR:extended;
 res:array [0..959] of byte;
 sr:array [0..959] of integer; //     
 test:tbitmap;
 PS1:array of PARGB;
 max,maxX,sum:integer;
 centrs:array [0..39] of integer; //   
 search:boolean;
 x:tmemorystream; 
begin
 test:=tbitmap.Create;
 test.PixelFormat:=pf24bit;
 test.Width:=960;
 test.Height:=SampleRate div 2;
 setlength(PS1,test.Height);
 for i:=0 to High(PS1) do PS1[i]:=test.scanline[i];
 
 delta:=2*360/SampleRate;
 DR:=2*(458/39)/SampleRate; //    458/39 -    
 ProgressBar1.Max:=test.Height;
 c:=FindCenter;
 for i:=0 to 959 do sr[i]:=0;

 for j:=0 to test.Height-1 do begin
  ugol:=90-j*delta;
  if ugol<0 then ugol:=360-abs(ugol);
  for i:=0 to 959 do begin
   z:=Ang2Point(ugol,i-(j*DR));
   res[i]:=PS[doedin(c.A+z.B),doedin(c.B+z.A)].r;
   sr[i]:=sr[i]+res[i];
   PS1[j,i].r:=res[i];
   PS1[j,i].g:=res[i];
   PS1[j,i].b:=res[i];
  end;
  ProgressBar1.StepIt;
 end;

 for i:=0 to 959 do sr[i]:=doedin(sr[i]/test.Height);
 search:=false;
 k:=0;
 max:=0;
 maxX:=0;
 for i:=958 downto 450 do begin
  sum:=0;
  for j:=0 to 4 do sum:=sum+sr[i-j];

  if sum>350 then search:=true;

  if search and (sum>max) then begin
   max:=sum;
   maxX:=i;
  end;

  if search and (sum<350) then begin
   max:=0;
   search:=false; // 
   centrs[k]:=maxX-2;
   inc(K);
   if k=40 then break;
  end;
 end;

 k:=0;
 for i:=0 to 39 do begin
  for j:=0 to test.Height-1 do begin
   sum:=((PS1[j,centrs[i]].r+PS1[j,centrs[i]-1].r+PS1[j,centrs[i]+1].r) div 3)-20;
   data1[k]:=byte(sum);
   inc(k);
  end;
 end; 

 ProgressBar1.Position:=0;

 x:=tmemorystream.Create;
 try
  x.Write(head1,44);
  x.Write(data1[0],head1.DataBytes);
  x.SaveToFile(musfile);
 finally
  x.Free;
 end; 
// test.SaveToFile('C:\test.bmp');
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
 if opendialog1.Execute then begin
  button1.Enabled:=false;
  MediaPlayer1.Close;
  OpenPic(opendialog1.FileName);
  ProImage;
  MediaPlayer1.FileName:=musfile;
  MediaPlayer1.Open;
  button1.Enabled:=true;  
 end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
 sour:=tbitmap.Create;
 sour.PixelFormat:=pf24bit;
 Channels:=1;
 SampleRate:=22050; 
 Resolution:=8;
 Duration:=20000; //  
 head1.BytesPerSecond:=(Channels * SampleRate * Resolution) div 8 ;
 head1.DataBytes:=(head1.BytesPerSecond) * (Duration div 1000);
 head1.Marker1:='RIFF';
 head1.BytesFollowing:=head1.DataBytes + 36;
 head1.Marker2:='WAVE';
 head1.Marker3:='fmt ';
 head1.Fixed1:=16;
 head1.FormatTag:=1;
 head1.SampleRate:=SampleRate;
 head1.Channels:=Channels;
 head1.BytesPerSample:=Channels * Resolution div 8;
 head1.BitsPerSample:=Resolution;
 head1.Marker4:='data'; 
 setlength(data1,head1.DataBytes);
end;

end.
